#ifndef __NEBULA_DEVICE_H__
#define __NEBULA_DEVICE_H__

#include "NebulaDevice.h"
#include "IOTCDevice.h"
#include "AVServer.h"
#include "VSaaS.h"
#include "P2PCam/AVFRAMEINFO.h"
#include "P2PCam/AVIOCTRLDEFs.h"
#include "LAN_WiFi_config/Device_LAN_WiFi_Config.h"
#include "emulator/emulator.h"
#include "disposable_params.h"
#include "playback/playback.h"
#include "speaker/speaker.h"
#include "Nebula_User_PSK_Manager/pskManager.h"
#include <winsock2.h>
#include <ws2tcpip.h>
#include <windows.h>


#define ENABLE_EMULATOR 0
#define ENABLE_DTLS 1 // 0:disable DTLS; 1:enable DTLS
#define ENABLE_RESEND 1 // 0:disable RESEND; 1:enable RESEND

#define FPS 5 //Video FPS
#define VIDEO_BUF_SIZE (1024 * 300)

#define AUDIO_BUF_SIZE 1024
#define AUDIO_FRAME_SIZE 640
#define AUDIO_FPS 25
#define AUDIO_CODEC MEDIA_CODEC_AUDIO_PCM

#define MAX_CLIENT_NUMBER 10
#define SERVTYPE_STREAM_SERVER 0

#define GO_TO_SLEEP_AFTER_NO_SESSION_WITH_SEC 10
#define MAX_WAKEUP_PATTERN_LENGTH 100
#define AV_LIVE_STREAM_CHANNEL 0

enum BindType {
    DISABLE_BIND,
    SERVER_BIND,
    LOCAL_BIND
};

typedef struct
{
    int av_index;
    unsigned char enable_video;
    unsigned char enable_audio;
    unsigned char two_way_stream;
    unsigned char enable_record_video;
    unsigned char enable_speaker;
    HANDLE lock;
    char playback_file[64];
    FILE* playback_file_fd;
    FILE* playback_file_info_fd;
    FILE* playback_audio_fd;
    int do_clean_buffer;
    int do_clean_buffer_done;
    int wait_key_frame;
} AV_Client;


unsigned int GetTimeStampMs();
int StartAvServer(int sid, unsigned char chid, unsigned int timeout_sec, unsigned int resend_buf_size_kbyte, int *stream_mode);

#endif
